<template>
  <div v-if="nodedata.name" class="node" ref="nodeElement">
    {{ nodedata.name }}
    <div v-for="(action, index) in nodedata.actions" :key="index">
      <Line
        :end="action.next"
        :nodeElement="nodeElement"
        :dragEvent="dragEvent"
      />
    </div>
  </div>
</template>

<script>
import { onMounted, ref, getCurrentInstance } from "vue";
import Line from "../components/Line.vue";
import PlainDraggable from "plain-draggable";

export default {
  name: "Node",
  setup(props, { emit }) {
    const nodeElement = ref(null);
    const dragEvent = ref(null);
    const currentInstance = getCurrentInstance();

    onMounted(() => {
      currentInstance.draggable = new PlainDraggable(nodeElement.value); // make draggable
      currentInstance.draggable.onDrag = function(e) {
        e.element = nodeElement.value;
        emit("dragEvent", e);
        dragEvent.value = e; // to hand event down to children
      };
    });
    return { nodeElement, dragEvent };
  },
  props: {
    nodedata: Object,
  },
  emits: ["dragEvent"],
  components: {
    Line,
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.node {
  position: absolute;
}
</style>
